#!/usr/bin/perl -w

my $confSendinfo    = "/usr/sbin/sendnodeinfo.perl";
my $confGetinfo     = "/usr/sbin/getnodeinfo.perl";
my $confCrontab     = "/etc/cron.d/triumf_nodeinfo";
my $confTimeout     = 5*60;

if (@ARGV == 0)
  {
    print STDERR "Usage:\n";
    print STDERR "   $0 host:port host:port...\n";
    print STDERR "   $0 --config host:port host:port...\n";
    print STDERR "Example:\n";
    print STDERR "   $0 send.triumf.ca:8600\n";
    exit 1;
  }

if ($ARGV[0] eq "--config")
  {
    shift @ARGV;
    my $dest = join(" ",@ARGV);
    my $min  = int(60*rand());
    my $hour = 1+int(4*rand());

    my $cronentry = "$min $hour * * * root $confSendinfo $dest";

    open(TMPOUT,">$confCrontab") || die "Cannot write to $confCrontab: $!";
    print TMPOUT "# crontab entry for triumf_nodeinfo\n";
    print TMPOUT "# created by ".$0." --config ".join(" ",@ARGV)."\n";
    print TMPOUT "$cronentry\n";
    close TMPOUT;

    print STDERR "$confCrontab updated: $cronentry\n";

    system "touch /etc/crontab";
    exit 0;
  }

alarm $confTimeout;
my $data = `perl $confGetinfo`;

use IO::Socket::INET;
foreach my $dest (@ARGV)
  {
    my $s = IO::Socket::INET->new(PeerAddr => $dest);
    if (! defined $s)
      {
        print STDERR "Cannot connect to $dest: $!\n";
        next;
      }

    print $s $data;
    $s->close;
  }

exit 0;

#end file
